]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - rpm.macros
- added comment for %skip_post_check_so
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
397b586d 1# $Revision$, $Date$
f51bfb2f
ER
2# PLD Linux rpm macros.
3# <http://www.pld-linux.org/>
d54662bf 4
2b05614d 5# can be used by builder script to check for version
98c5c988
ER
6%rpm_build_macros %(R="$Revision$"; RR="${R##: }"; echo ${RR%%?})
7
e05017c1 8%epoch 0
3241033b 9%x8664 x86_64 amd64 ia32e
e483e029 10%arm armv3l armv4b armv4l armv5teb armv5tel
9c404149 11
ba1fdedc 12# kernel compiler
345d14e5 13%kgcc %{__cc}
d2e1bc22 14%kgcc_package gcc
ba1fdedc 15
46763914 16# compiler version
69bcfbf3 17%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
de629430 18%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
46763914 19
69bcfbf3 20%__rm /bin/rm --interactive=never
36eccf0d 21
33040789 22# Build system path macros.
69bcfbf3
ER
23%__autoconf autoconf %{?debug:-Wall}
24%__automake automake -a -c -f --foreign
25%__autopoint autopoint --force
26
27# add parallel build flags: -jN
a5656a95 28#
11ecb0a1
ER
29# if you want to disable parallel build do:
30# echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
a5656a95 31#
11ecb0a1
ER
32%__make /usr/bin/make %{?_smp_mflags}
33%__scons /usr/bin/scons %{?_smp_mflags}
34%__waf /usr/bin/waf %{?_smp_mflags}
b8f83d42 35%__cmake /usr/bin/cmake
a5656a95
JR
36
37%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
38 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
f93109a0 39
83094b62 40%__gettextize { \
8a995cff 41 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 42 gettextize --copy --force --no-changelog; \
97589b6e 43 else \
3241033b 44 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
45 fi; \
46 if [ ! -f po/Makevars ]; then \
3241033b 47 cp -f po/Makevars{.template,}; \
8a995cff 48 fi; \
8a995cff 49}
f93109a0 50
51%__glib_gettextize glib-gettextize --copy --force
52%__gnome_doc_common gnome-doc-common --copy
fb59e475 53%__gnome_doc_prepare gnome-doc-prepare --copy --force
f93109a0 54%__gtkdocize gtkdocize --copy
55%__intltoolize intltoolize --copy --force
c26f1b59 56%__libtoolize libtoolize --copy --force --install
33040789 57
751c2bdd
ER
58# topdir is where builder script lives,
59# fallback to old style if SPECS/SOURCES dirs were found.
60%_topdir %{expand:%%global _topdir %(
61 if [ -d SPECS -a -d SOURCES ]; then
62 # old style rpmdir: in topdir
df3151c2 63 pwd
751c2bdd
ER
64 elif [ -d ../SPECS -a -d ../SOURCES ]; then
65 # old style rpmdir: in subdir
df3151c2 66 cd ..; pwd
751c2bdd
ER
67 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
68 # if old style rpm dir exist, go with it
69 echo $HOME/rpm; \
70 elif [ -x ../builder -a ! -d ../builder ]; then
71 # relative new style rpmdir: in package dir
df3151c2 72 cd ..; pwd
751c2bdd
ER
73 elif [ -x builder -a ! -d builder ]; then
74 # relative new style rpmdir: in packages
df3151c2 75 pwd
751c2bdd
ER
76 elif [ -x packages/builder -a ! -d packages/builder ]; then
77 # relative new style rpmdir: packages dir in current dir
df3151c2 78 cd packages; pwd
751c2bdd
ER
79 else
80 # fallback to new style rpmdir
81 echo $HOME/rpm/packages
82 fi; \
83)}%_topdir
1052b4b8 84
751c2bdd
ER
85# if %{_topdir}/SPECS exists, it's old style structure
86%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
87%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
1052b4b8
ER
88
89# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
90# if they don't exist assume we are having custom topdir (which is not named as
91# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
df3151c2
ER
92# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therfore the extra echo
93%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
94%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
95%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
384e1b2b 96
81e450f7
ER
97# The number of cvs changelog entries kept when building package.
98%_buildchangelogtruncate 20
99
6a5eda77 100%dependencytracking %{nil}
3241033b 101
e5da9169
ER
102# Relations between package names that cause dependency loops
103# with legacy packages that cannot be fixed. Relations are
104# specified as
105# p>q
106# where package p has a Requires: on something that package q Provides:
107#
108# XXX Note: that there cannot be any whitespace within the string "p>q",
109# and that both p and q are package names (i.e. no version/release).
110%_dependency_whiteout %{nil}
111
810fa5c4 112#-----------------------------------------------------------------
113#
114# (re)definition of %{rpm*flags} with %filterout_* support
b5e977c5
ER
115# BuildRequires: awk
116# BuildRequires: rpmbuild(macros) >= 1.315
810fa5c4 117#
118# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
09a90176 119# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
120# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
98e7f050 121# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
09a90176 122# %rpmldflags = %optldflags - %filterout_ld
810fa5c4 123#
124# Regular expressions are supported, but to avoid some character be treated
125# as regular expression it must be escaped twice.
126
127%filter_out \
7b6f1112 128 for (i = 1; i in I; i++) { A=0; \
810fa5c4 129 for (f in F) { \
130 if (I[i] ~ "^" F[f] "$") A=1; \
131 }; \
132 if (!A) printf(I[i] FS); \
133 }
134
135%rpmcflags %(awk 'BEGIN {
136 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
09a90176 137 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
810fa5c4 138 %{filter_out}
139}')
140
141%rpmcxxflags %(awk 'BEGIN {
09a90176 142 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
143 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
810fa5c4 144 %{filter_out}
145}')
146
98e7f050
AM
147%rpmcppflags %(awk 'BEGIN {
148 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
149 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
150 %{filter_out}
151}')
152
810fa5c4 153%rpmldflags %(awk 'BEGIN {
c05a0741 154 split("%{?optldflags}",I);
810fa5c4 155 split("%{?filterout_ld}",F)
156 %{filter_out}
157}')
158
25f52d1a 159# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
160# but, don't use it, better use gcc as linker
161%ld_rpmldflags %(awk 'BEGIN {
162 split("%{rpmldflags}",F);
163 for (f in F) {
164 s = F[f];
165 if (s ~ /^-Wl,/) {
166 s = substr(s,5);
167 gsub(/,/," ",s);
168 };
169 printf(s FS);
170 };
171}')
172
8ef644e5 173#-----------------------------------------------------------------
174#
175# Generate a command which cleans environment, leaving only the
176# most important variables.
177# If any spec requires any additional environment it should
178# redefine %_preserve_env in following manner:
179#
180# # ADDITIONAL_VAR is required because [a good reason here]
82d10503 181# %define _preserve_env ADDITIONAL_VAR
8ef644e5 182
57ba0f59 183%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
8ef644e5 184
bb597f2b
AM
185# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
186%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
0bdc88ec 187 split("%{?_preserve_env}", P);
a363d727
ER
188 for (i in P) {
189 p = P[i];
82d10503
ER
190 if (!ENVIRON[p] || d[p]) {
191 continue;
8ef644e5 192 }
82d10503
ER
193 d[p] = 1;
194 split(ENVIRON[p], V, "");
195 val = p "=";
196 for (j = 1; j in V; j++) {
197 v = V[j];
198 if (v == q)
199 v = qq;
200 else if (v == "\\"")
201 v = q2q;
202 else if (v == "\\\\")
203 v = "\\\\\\\\";
204 else
205 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
206 val = val "" v;
207 }
208 printf(val " ");
8ef644e5 209 }
210}')
211
9c404149 212#-----------------------------------------------------------------
9f4ce098 213%configure2_13 { \
9c404149
AM
214 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
215 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
216 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 217 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 218 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
e9d801f4 219 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
98e7f050 220 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
8983c4c4
AM
221 %{?__cc:CC="%{__cc}" ; export CC ; } \
222 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 223 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 224 --host=%{_target_platform} \
9c404149
AM
225 --prefix=%{_prefix} \
226 --exec-prefix=%{_exec_prefix} \
227 --bindir=%{_bindir} \
228 --sbindir=%{_sbindir} \
229 --sysconfdir=%{_sysconfdir} \
230 --datadir=%{_datadir} \
231 --includedir=%{_includedir} \
232 --libdir=%{_libdir} \
233 --libexecdir=%{_libexecdir} \
234 --localstatedir=%{_localstatedir} \
235 --sharedstatedir=%{_sharedstatedir} \
236 --mandir=%{_mandir} \
237 --infodir=%{_infodir} \
b6c5da52 238 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 239 %{dependencytracking} \
9c404149
AM
240}
241
c4a85bd8 242%cmake \
d41caea6
ER
243%{?__cc:CC="%{__cc}"} \\\
244%{?__cxx:CXX="%{__cxx}"} \\\
245CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
246CFLAGS="${CFLAGS:-%{rpmcflags}}" \\\
247FFLAGS="${FFLAGS:-%{rpmcflags}}" \\\
248FCFLAGS="${FCFLAGS:-%{rpmcflags}}" \\\
249CXXFLAGS="${CXXFLAGS:-%{rpmcxxflags}}" \\\
250LDFLAGS="${LDFLAGS:-%{rpmldflags}}" \\\
c4a85bd8 251%{__cmake} \\\
8736ae44 252 -DCMAKE_VERBOSE_MAKEFILE=ON \\\
c4a85bd8 253 -DCMAKE_BUILD_TYPE=%{!?debug:Release}%{?debug:Debug} \\\
8736ae44
ER
254 -DCMAKE_INSTALL_LIBDIR:PATH=%{_libdir} \\\
255 -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \\\
256 -DINCLUDE_INSTALL_DIR:PATH=%{_includedir} \\\
257 -DLIB_INSTALL_DIR:PATH=%{_libdir} \\\
258 -DSHARE_INSTALL_PREFIX:PATH=%{_datadir} \\\
259 -DSYSCONF_INSTALL_DIR:PATH=%{_sysconfdir} \\\
c27b3ff8 260%if "%{_lib}" == "lib64" \
c4a85bd8 261 -DLIB_SUFFIX=64 \\\
9d1e0c01 262%endif \
8736ae44 263 -DBUILD_SHARED_LIBS:BOOL=ON \\\
c4a85bd8 264%{nil}
89f4ca1f 265
89f4ca1f
ER
266%scons { \
267%{__scons} \
5c76736d
ER
268 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
269 CFLAGS="${CFLAGS:-%rpmcflags}" \
270 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
271 FFLAGS="${FFLAGS:-%rpmcflags}" \
98e7f050 272 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
5c76736d
ER
273 %{?__cc:CC="%{__cc}"} \
274 %{?__cxx:CXX="%{__cxx}"} \
275 libsuffix=%{_lib} \
276 prefix=%{_prefix} \
39b9534b
ER
277}
278
6339d32d 279# waf. see waf.spec
6339d32d 280%waf { \
6339d32d
ER
281CC="%{__cc}" \
282CXX="%{__cxx}" \
9e244007 283CPP="%{__cpp}" \
6339d32d
ER
284CFLAGS="%{rpmcflags}" \
285CXXFLAGS="%{rpmcxxflags}" \
286%{__waf} \
6339d32d
ER
287}
288
4a6b0d54 289#----------------------------------------------------------------
9bacbb5b 290#%configure_cache 0
fe6c4bdd 291%configure_cache_file %{buildroot}.configure.cache
73f832b3 292
e84cd836 293%configure {./configure \
4a6b0d54
AF
294 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
295 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 296 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 297 FFLAGS="${FFLAGS:-%rpmcflags}" \
e9d801f4 298 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
98e7f050 299 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
8983c4c4
AM
300 %{?__cc:CC="%{__cc}"} \
301 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 302 --host=%{_target_platform} \
4a6b0d54
AF
303 --build=%{_target_platform} \
304 --prefix=%{_prefix} \
305 --exec-prefix=%{_exec_prefix} \
306 --bindir=%{_bindir} \
307 --sbindir=%{_sbindir} \
308 --sysconfdir=%{_sysconfdir} \
309 --datadir=%{_datadir} \
310 --includedir=%{_includedir} \
311 --libdir=%{_libdir} \
312 --libexecdir=%{_libexecdir} \
313 --localstatedir=%{_localstatedir} \
314 --sharedstatedir=%{_sharedstatedir} \
315 --mandir=%{_mandir} \
316 --infodir=%{_infodir} \
b6c5da52 317 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 318 %{dependencytracking} \
9bacbb5b 319 %{?configure_cache:--cache-file=%{configure_cache_file}} \
4a6b0d54
AF
320}
321
611a25d5 322# Simple macros to simplify adding bconded options to configure scripts.
323# Each macro requires bcond name and accepts optional option name, if option
324# isn't specified bcond name is used as option name. Options returning
325# --with and --enable also allow third argument which will be added as value
326# ( --with-option=value or --enable-option=value ) in case or positive
327# condition, but won't be added otherwise ( nothing or just --disable-option ).
328
329# Requirements:
330# BuildRequires: rpmbuild(macros) >= 1.527
331
332# Usage example:
333# %{__enable bcond} - returns --enable-bcond iff build condition is set
334# %{__disable bcond option} - returns --enable-option iff bcond is not set
335# %{__enable_disable bcond option value} - returns --enable-option=value if
336# bcond is set, returns --disable-option otherwise
337
338# expand bconds to --enable-something and --disable-something
339%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
340%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
341%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
342
343# same as above, but condition inverted
344%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
345%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
346%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
347
348# expand bconds to --with-something and --without-something
349%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
350%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
351%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
352
353# same as above, but condition inverted
354%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
355%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
356%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
357
358#-----------------------------------------------------------------
359
b3b1397b
ER
360# overload to insert debuginfo package
361%prep \
362%if 0%{?_enable_debug_packages}\
363%{debug_package}\
364%endif\
365%%prep\
366%{nil}
367
9c404149 368# Location of autoconf macros
ef7d5e14 369%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
9c404149 370
e2804f99 371# Location of omf files
7f0f4a79 372%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
e2804f99 373
e987a186 374# Location of pkgconfig files
9a4e877a 375%_pkgconfigdir /usr/%{_lib}/pkgconfig
36219c36
JB
376# noarch pkgconfig files
377%_npkgconfigdir /usr/share/pkgconfig
e987a186 378
486b0b5f 379# Location of desktop files
380%_desktopdir /usr/share/applications
86dff2d0 381%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 382
481463e9 383# Location of pixmaps for applnk/desktop files
e1f0a822 384%_pixmapsdir /usr/share/pixmaps
9c404149 385
481463e9 386# Location of themable icons for applnk/desktop files
b36c8e2a 387%_iconsdir /usr/share/icons
388
e987a186
JB
389# Location of fonts directories
390%_fontsdir /usr/share/fonts
391
b3282f3f 392# Location of Gtk and associated libraries documentation
fe6c4bdd 393%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 394
fc4d7771 395# Location of KDE documentation
fe6c4bdd 396%_kdedocdir %{_defaultdocdir}/kde/HTML
fc4d7771 397
5869828c 398# unsermake script
399%__unsermake /usr/share/unsermake/unsermake
400
9c404149 401# Current date
8cf161e2 402%date %(LC_ALL=C date +"%a %b %d %Y")
9c404149 403
9c404149
AM
404# Example files, programs, scripts...
405%_examplesdir /usr/src/examples
406
c8f7e820 407# Alternative kernel type/version
261729d9 408%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
c8f7e820 409
8377d27d 410# The directory holding Linux kernel sources
261729d9 411%_kernelsrcdir /usr/src/linux%{_alt_kernel}
8377d27d 412
c0fe61f0
ER
413# SysV-style initscripts dir
414%_initddir /etc/rc.d/init.d
415
9c404149 416# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 417%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 418
590bc1db 419# Bootstrap release macros.
420# Usage:
421# %bcond_with bootstrap
422# Release: %{bootstrap_release 1}
423#
424# Package will have release 1 if built normally,
425# and release 0.zzz.bootstrap if built with bootstrap
426%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
427
c924d9d8
ER
428# -n drm to generate kernel%{_alt_kernel}-drm dependency
429%releq_kernel(n:) %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
430%releq_kernel_up(n:) %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
431%releq_kernel_smp(n:) %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
8bf3719d 432
c924d9d8 433# -s post to generate Requires(post) dependency
63d9963a
ER
434%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
435%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
436%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
8bf3719d 437
410df6e8
ER
438# Requires name = version-release
439%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
8cf161e2 440# Requires: name = version
91d2f1eb 441%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
8cf161e2 442# Requires: name = version (version based on querying package %2)
0d3e64c0 443%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
01a9f990 444
90c674d3
JR
445# Requires: name >= version
446%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
447# Requires: name >= version (version based on querying package %2)
448%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
449
c94807f3 450%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
b9d5d440 451
452# kernel version-release handling
95125403 453%__kernel_ver %{expand:%%global __kernel_ver %( \\
acac3049 454 Z=$([ -f '%{_kernelsrcdir}/include/generated/utsrelease.h' ] && awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/{linux/version,generated/utsrelease}.h 2>/dev/null || awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
95125403
ER
455 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
456 echo ${Z:-ERROR}; \\
1a7d3518 457)}%__kernel_ver
95125403 458
c94807f3
ER
459%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
460%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
461%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
462%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
87be1cf0 463
6262f001
ER
464# `uname -r` to be used in @release field
465%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
466
e00dd7f6 467# sgml macros
3241033b
ER
468%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
469%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
470%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
471%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
472%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
473%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 474%docbook_sgmlcat_fix() { for l in \
475'' \
476' -- default decl --' \
477'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
478' -- hacks for opensp --' \
479'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
480'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
481'' \
482; do echo $l; done >> %1 \
483}
484
eea64748
ER
485# vim - "
486
4f044018
ER
487# minimum file size needed for compressed documents.
488# just smaller files than this get larger when compressed.
a88ae20f
ER
489# some stats:
490# - 0 byte file compressed was 25 bytes .gz
491# - 39 byte file was compressed as 57
492# - with test/test.spec@man 158 byte file was compressed also 158
493%_min_compress_bytes 159
4f044018 494
9c404149
AM
495#-----------------------------------------------------------------
496# find and gzip all files in %{_mandir} and %{infodir}
497#
498# Requires: xargs, find
499#
500#%no_install_post_compress_docs 1
501%__spec_install_post_compress_docs { \
53d5af13 502%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
4e10ec06 503 for i in /usr/share/man /usr/X11R6/man; do \
9c404149 504 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
4e10ec06 505 echo "Compress man pages: $i"; \
4f044018
ER
506 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
507 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
6375241c
ER
508 find $RPM_BUILD_ROOT$i -type l | while read a; do \
509 m=$(readlink $a); \
510 rm -f $a; \
511 echo .so ${m##*/} > $a; \
512 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
513 done; \
4f044018 514 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
9c404149
AM
515 fi; \
516 done; \
728ad671
JB
517 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
518 echo "Compress info pages: %{_infodir}"; \
519 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
520 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
521 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
4e10ec06 522 fi; \
53d5af13 523}; __spec_install_post_compress_docs } }
9c404149
AM
524
525#-----------------------------------------------------------------
526# Strip executable binaries and shared object files
527#
528# Requires: find, awk, strip, cut, xargs
529#
a2ad2754
JB
530# Special macros which affect this process:
531#%no_install_post_strip 1 # disable stripping at all
532#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
533#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
534#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
535#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
536#
9c404149 537%__spec_install_post_strip {%{!?debug: \
53d5af13 538%{!?no_install_post_strip:__spec_install_post_strip() { \
98a06bad 539if [ -d "$RPM_BUILD_ROOT" ]; then \
eea64748
ER
540 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
541 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
542 if [ "$modulelist" ]; then \
543 modulecount=$(echo "$modulelist" | wc -l); \
737fefdc 544 printf "Stripping %d kernel modules..." $modulecount; \
3df8db34
ER
545 echo "$modulelist" | xargs -l512 chmod u+w; \
546 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
547 echo "DONE"; \
548 fi; \
eea64748 549 fi; \
0ac49134 550 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
f89ccb5f
JB
551 if [ -n "$filelist" ]; then \
552 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
553 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
554 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
a2ad2754 555 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
f89ccb5f 556 if [ -n "$elfexelist" ]; then \
4d5370ac 557 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
f89ccb5f
JB
558 chmod u+w $elfexelist; \
559 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
560 echo "DONE"; \
561 fi; \
562 if [ -n "$elfsharedlist" ]; then \
4d5370ac 563 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
f89ccb5f
JB
564 chmod u+w $elfsharedlist; \
565 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
566 echo "DONE"; \
567 fi; \
568 if [ -n "$archiveslist" ]; then \
4d5370ac 569 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
f89ccb5f
JB
570 chmod u+w $archiveslist; \
571 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
572 echo "DONE"; \
573 fi; \
98a06bad 574 fi; \
0ac49134
ER
575 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
576 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
577 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
f89ccb5f 578 if [ -n "$filelist_all" ]; then \
4d5370ac 579 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
a2ad2754 580 chmod u+w $filelist_all; \
f89ccb5f 581 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
322f84b9 582 echo "DONE"; \
9c404149 583 fi; \
f89ccb5f 584 if [ -n "$filelist_unneeded" ]; then \
4d5370ac 585 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
a2ad2754 586 chmod u+w $filelist_unneeded; \
f89ccb5f 587 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
322f84b9 588 echo "DONE"; \
8f74418b 589 fi; \
f89ccb5f 590 if [ -n "$filelist_debug" ]; then \
4d5370ac 591 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
a2ad2754 592 chmod u+w $filelist_debug; \
f89ccb5f 593 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
322f84b9 594 echo "DONE"; \
9f0d4f36 595 fi; \
53d5af13 596fi; }; __spec_install_post_strip } } }
3241033b 597
fc5d7e20 598#-----------------------------------------------------------------
599# remove all RPATH from executable binaries and shared object files
600#
601# Requires: find, awk, cut, xargs, chrpath, uname
602#
a2ad2754
JB
603# Special macros which affect this process
604#%no_install_post_chrpath 1 # disable chrpath at all
605#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
606#
fc5d7e20 607%__spec_install_post_chrpath {%{!?debug: \
53d5af13 608%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
9f0d4f36 609if [ -d "$RPM_BUILD_ROOT" ]; then \
0ac49134 610 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
98a06bad 611 if [ -n "$files" ]; then \
d5517264 612 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
3401a2cd 613 fi; \
98a06bad 614 if [ -n "$objs" ]; then \
4d5370ac 615 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
98a06bad
ER
616 echo "$objs" | \
617 while read file; do \
618 rpath= ; \
619 chmod u+w "$file"; \
5541bf26 620 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
eda6b510
AM
621 case $dir in \
622 '$ORIGIN' ) \
623 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
624 else rpath="$rpath:$dir" ; fi ; \
625 continue ; \
626 ;; \
627 esac ; \
f9abaddb
AM
628 newdir=$(readlink -m "$dir"); \
629 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
98a06bad
ER
630 case $dir in \
631 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
632 echo "remove-rpath: $dir in $file"; \
633 ;; \
634 * ) \
635 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
636 else rpath="$rpath:$dir" ; fi ; \
637 ;; \
638 esac ; \
639 done ; \
640 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
641 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
642 done; \
643 fi; \
53d5af13 644fi; }; __spec_install_post_chrpath } } }
3241033b 645
611a25d5 646# vim: "
647
d366d7e0
AM
648#-----------------------------------------------------------------
649# Find all shared object files with unresolved symbols. Warn
650# and terminate if any found (termination can be turned off by define).
651#%no_install_post_check_so 1
ff8c88f6 652#%skip_post_check_so libwithunresolvedok.so.*
e067aec9 653#
654# NOTE: define skip_post_check_so only if such library really requires
655# unresolved symbols and always leave a comment why it is required:
656# # executable provides symbols foo, bar for those libraries:
657# %define skip_post_check_so libwithoutfoo.so.* libwithoutbar.so.*
658#
d366d7e0
AM
659%__spec_install_post_check_so { \
660 __spec_install_post_check_so() { \
661 fail=0; \
662 printf "Searching for shared objects with unresolved symbols..."; \
34906a2d 663 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
b6c601e3 664 %{?skip_post_check_so:awk -v "file=$f" 'BEGIN { split("%{skip_post_check_so}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") exit(1); } }' || continue;} \
7df9ddfc 665 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
d366d7e0
AM
666 done ; \
667 echo " DONE"; \
603b05a4 668 %{!?no_install_post_check_so:return $fail;} \
d366d7e0
AM
669}; __spec_install_post_check_so }}
670
d72c185f 671#-----------------------------------------------------------------
ccb8ae8d 672# Find and gzip all kernel modules
673#
674# Requires: find
675#
fe6c4bdd 676#%no_install_post_compress_modules 1
ccb8ae8d 677%__spec_install_post_compress_modules { \
53d5af13 678%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
f3bfe4ac 679 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
f3bfe4ac 680 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
681 if [ "$q" ]; then \
682 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
683 echo "$q" | xargs -r %{__gzip} -9nf; \
684 echo "DONE"; \
685 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
686 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
687 fi; \
3241033b 688 fi; \
53d5af13 689}; __spec_install_post_compress_modules } }
9c404149 690
ef64802f
ER
691# Remove common Perl files we don't package
692%__spec_install_post_perl_clean {\
693%{!?no_install_post_perl_clean: \
694%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
695} }
696
83094b62 697#-----------------------------------------------------------------
0e4cb4dd 698# Update GConf2 schemas
83094b62 699#
700# Requires: GConf2
701#
46885239 702%gconf_schema_install() \
307ac6c9
ER
703 umask 022; \
704 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
705 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
f27cf2fd 706%{nil}
46885239 707
708%gconf_schema_uninstall() \
24336a54 709if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
3241033b 710 umask 022; \
24336a54
ER
711 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
712 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f27cf2fd 713fi; \
f93109a0 714%{nil}
715
716#-----------------------------------------------------------------
717# Update desktop MIME database
c0a4caa0 718# requires: desktop-file-utils
c3bcd10e 719%update_desktop_database() {{ \
f93109a0 720 umask 022; \
fb59e475 721 /usr/bin/update-desktop-database -q; \
c00bf95c
MB
722};} \
723%{nil}
f93109a0 724
c3bcd10e
ER
725%update_desktop_database_post %update_desktop_database
726
727%update_desktop_database_postun() {{ \
f27cf2fd 728if [ "$1" = "0" ]; then \
c00bf95c 729 %update_desktop_database \
f27cf2fd 730fi; \
c00bf95c
MB
731};} \
732%{nil}
f93109a0 733
fb59e475 734#-----------------------------------------------------------------
735# Update shared MIME info database
736# requires: shared-mime-info
737#
c3bcd10e 738%update_mime_database() {{ \
fb59e475 739 umask 022; \
740 /usr/bin/update-mime-database %{_datadir}/mime; \
c00bf95c
MB
741};} \
742%{nil}
fb59e475 743
744#-----------------------------------------------------------------
745# Update icon cache
746# requires: gtk+
747#
c3bcd10e 748%update_icon_cache() {{ \
fb59e475 749 umask 022; \
072f4b80 750 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
c00bf95c
MB
751};} \
752%{nil}
fb59e475 753
f93109a0 754#-----------------------------------------------------------------
755# Update scrollkeeper database
756# requires: scrollkeeper
757#
758%scrollkeeper_update_post() \
f93109a0 759 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 760%{nil}
f93109a0 761
762%scrollkeeper_update_postun() \
f27cf2fd 763if [ "$1" = "0" ]; then \
f93109a0 764 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 765fi; \
f93109a0 766%{nil}
767
9c404149
AM
768#-----------------------------------------------------------------
769# post %install sequence:
770# - autodeps exceptions
771# - compress all man and info pages,
772# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 773# - compress kernel modules if any
9c404149
AM
774
775###################################################################
776# Requires/Provides automation
3e202b06 777# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
338726a6 778#
2892b5df
JB
779%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
780%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
781%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
782%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
783%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
c94807f3 784
338726a6
JB
785#%_noautocompressdoc %{nil}
786#
8f74418b
MM
787%_missing_doc_files_terminate_build 1%{nil}
788%_unpackaged_files_terminate_build %{nil}
8781dc74 789# (X)emacs support
d77dcb61 790%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
c94807f3
ER
791%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
792%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
25043cd4 793
02b58f60
JK
794%__php_provides %{nil}
795%__php_requires %{nil}
796%__perl_provides %{nil}
797%__perl_requires %{nil}
fa3497cd 798%__mono_provides %{nil}
799%__mono_requires %{nil}
25043cd4
AF
800
801# Perl specific macro definitions.
c94807f3
ER
802%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
803%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
804%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
805%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
806%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
807%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
25043cd4 808
45c00b39 809# Ruby
c94807f3
ER
810%__ruby /usr/bin/ruby
811%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
812%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
813%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
814%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
815%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
816%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
817%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
751cfc9e 818%ruby_rdocdir /usr/share/rdoc
c94807f3 819%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
669604db
ER
820%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
821%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
45c00b39 822
7ccf7643 823%php_pear_dir /usr/share/pear
7813c433 824%php_data_dir /usr/share/php
c94807f3
ER
825%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
826%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
827%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
25043cd4 828
0c5d1b9b 829# extract php/zend api versions
c94807f3 830%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
e0d35dd1 831%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
c94807f3
ER
832%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
833%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
834%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
835%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
836%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
d9ca5910
ER
837%_zend_zts %{expand:%%global _zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%_zend_zts
838# "_ts" if ZTS enabled, empty otherwise
839%zend_zts %{expand:%%global _zend_zts_%{?_zend_zts} 1}%{?_zend_zts_1:_ts}
c1b2705c
ER
840
841# helper macro
f952c0f3 842%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
843
844# macros for public use
845# for php extensions (php-pecl)
68b68193 846%requires_php_extension %{__php_api_requires modules_api php_api_version} \
415f4a1a 847%{__php_api_requires zend_module_api} \
f952c0f3 848%{__php_api_requires -v %php_major_version debug php_debug} \
e2bc6159 849%{__php_api_requires -v %php_major_version thread-safety _zend_zts}
68b68193 850
c1b2705c
ER
851# for zend extensions
852%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 853%{__php_api_requires zend_extension_api} \
f952c0f3 854%{__php_api_requires -v %php_major_version debug php_debug} \
e2bc6159 855%{__php_api_requires -v %php_major_version thread-safety _zend_zts}
c1b2705c 856
934c685f
ER
857# for php pdo modules (php-pecl-PDO_*)
858%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
859
6c3b8203
ER
860# for using PHP post scripts. for PHP >= 5.0
861%php_webserver_restart \
862[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
578e7794 863[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
8e2cfc36 864if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
ba1800dc
ER
865 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
866 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
867 %service -q php-fcgi restart \
868 fi \
869fi \
8e2cfc36
ER
870if [ -x /etc/rc.d/init.d/php-fpm ]; then \
871 %service -q php-fpm restart \
872fi \
6c3b8203
ER
873%{nil}
874
875# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
876%php4_webserver_restart \
877[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
578e7794 878[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
8e2cfc36 879if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
ba1800dc
ER
880 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
881 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
882 %service -q php-fcgi restart \
883 fi \
884fi \
6c3b8203
ER
885%{nil}
886
578e9248 887# X.org helper macros
434ab5a2
ER
888%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
889%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
890
c94807f3
ER
891%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
892%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
893%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
894%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
895%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
611a25d5 896# vim: '
578e9248 897
434ab5a2 898%requires_xorg_xserver_extension \
97486460
AM
899%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
900%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
901%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
902%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
434ab5a2
ER
903%{nil}
904
905%requires_xorg_xserver_xinput \
97486460
AM
906%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
907%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
908%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
909%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
434ab5a2
ER
910%{nil}
911
912%requires_xorg_xserver_font \
97486460
AM
913%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
914%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
915%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
916%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
434ab5a2
ER
917%{nil}
918
919%requires_xorg_xserver_videodrv \
97486460
AM
920%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
921%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
922%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
923%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
434ab5a2 924%{nil}
578e9248 925
15d7cc4a
ER
926# TCL specific macro definitions.
927# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
928%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
929%tcl_sitearch %{_libdir}/tcl%{tcl_version}
930%tcl_sitelib %{_datadir}/tcl%{tcl_version}
931
25043cd4
AF
932# Python specific macro definitions.
933# python main version
2383a9da 934%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
25043cd4
AF
935
936# directories
2383a9da 937%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
3241033b 938%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 939%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 940%py_incdir /usr/include/python%{py_ver}
7ccf7643 941%py_sitedir %{py_libdir}/site-packages
ef7ec0a8 942%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 943%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
944
945# pure python modules compilation
3241033b 946%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 947
3241033b 948%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
949
950# Software written in Python language require Python with main version
e63cd81d 951%pyrequires_eq() Requires: %1
25043cd4 952
4bf34b55
AF
953# Python 3.x
954# python main version
e9f00395 955%__python3 python3
4bf34b55
AF
956%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
957
958# directories
959%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
960%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
961%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
962%py3_incdir /usr/include/python%{py3_ver}
963%py3_sitedir %{py3_libdir}/site-packages
964%py3_sitescriptdir %{py3_scriptdir}/site-packages
965%py3_dyndir %{py3_libdir}/lib-dynload
966
967# pure python modules compilation
968%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
969
970%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
971
f12c2314 972# Hardlink binary identical .pyc and .pyo files
f12c2314 973%__spec_install_post_py_hardlink {\
53d5af13 974%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
f35a1d62
ER
975local a b c=0 t=0; \
976if [ -d "$RPM_BUILD_ROOT" ]; then \
977 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
978 while read a; do \
979 b="${a%.pyc}.pyo"; \
980 if cmp -s "$a" "$b"; then \
981 ln -f "$a" "$b"; \
982 c=$((c + 1)); \
983 fi; \
984 t=$((t + 1)); \
985 done < __rpm_pyc; \
986 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
987 rm -f __rpm_pyc; \
988fi; \
53d5af13 989}; __spec_install_post_py_hardlink } }
f12c2314 990
9227b3f9 991# remove python sources, so that check-files won't complain
f12c2314 992%py_postclean() \
0f82e280 993for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 994 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
995done \
996%{nil}
997
4bf34b55
AF
998%py3_postclean() \
999for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
1000 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
1001done \
1002%{nil}
1003
0fc5cff8 1004# depmod macro
1005%depmod() { \
f6148427 1006umask 022; \
0fc5cff8 1007if [ -e /boot/System.map-%1 ]; then \
3241033b 1008 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 1009else \
3241033b
ER
1010 if [ -e /boot/System.map ]; then \
1011 /sbin/depmod -a -F /boot/System.map %1; \
1012 else \
1013 /sbin/depmod -a %1; \
1014 fi \
0fc5cff8 1015fi; \
1016}
1017
2afc6e64 1018# XMMS specific macros
c94807f3
ER
1019%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
1020%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
1021%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
1022%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1023%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1024%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1025%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1026%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1027%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1028%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1029
eb41c1ce 1030%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_target_base_arch
d1537778 1031
848c0d68 1032# user/group checking macros
1033#
1034# Usage:
1035# %userremove myuser
1036#
1037%userremove /usr/lib/rpm/user_group.sh user del
1038%groupremove /usr/lib/rpm/user_group.sh group del
1039#
1040# Usage:
1041# if %usertestrm myuser; then
1042# /usr/sbin/userdel -r myuser
1043# Note:
1044# use these macros only if you need to call userdel/groupdel with
1045# a non-standard option or take an extra action; otherwise use the
1046# %userremove/%groupremove macros
1047#
1048%usertestrm /usr/lib/rpm/user_group.sh user testrm
1049%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
1050# user group membership management macros
1051#
1052# Usage:
efbc7726 1053# %addusertogroup [-q] myuser agroup
08d9b1f6 1054#
efbc7726
ER
1055# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1056#
1057# Requirements:
1058# BuildRequires: rpmbuild(macros) >= 1.515
2b29e157
ER
1059%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1060%{nil}
72fcfcb3 1061
1062# banner support (useful in {pre,post}{,un} and triggers)
1063#
1064# Usage:
aa41c920 1065# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 1066# the banner text, the banner text
aa41c920
ER
1067# the banner text, and following line
1068#EOF
1069# You can use any form of here-document, <<'EOF' <<-EOT will do.
1070# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1071#
72fcfcb3 1072# -a - append to the banner
a8b9562a 1073# -e - send to stderr instead of stdout
628754cb 1074# -n - no show banner (overrides -t)
1075# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
276a7b45
ER
1076#
1077# Tests:
1078# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1079# rpm -E 'date | %banner -e banner' > m; sh -x m
1080#
afb54f6c 1081%banner(aent:) ( \
1b334fe4 1082RPM_SCRIPTVERBOSITY=5 \
1083[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1084if [ -x /usr/bin/banner.sh ]; then \
aa41c920 1085 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 1086else \
a8b9562a 1087 CMD="cat%{-e: >&2}" \
1b334fe4 1088fi \
276a7b45
ER
1089eval $CMD %{?2:%2}%{?3: %3}) \
1090%{nil}
628754cb 1091
990bd03f 1092# useradd/groupadd macros
4c73bc69 1093# Author: Elan Ruusamäe <glen@pld-linux.org>
90627280
ER
1094#
1095# Usage:
1096# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1097# [-g initial_group] [-G group[,...]] login
1098#
1099# -u uid. REQUIRED
1100# -g gid/group. REQUIRED
1101# -s defaults to /bin/false
1102# -d defaults to /usr/share/empty
1103# -c No default
1104# -r is accepted but ignored (it's always set)
6bd4c218 1105# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
1106# rpm specific flags
1107# -P package name. defaults to %{name}
1108#
90627280 1109%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
1110%{!-u:%{error:useradd: Required argument -u missing}} \
1111%{!-g:%{error:useradd: Required argument -g missing}} \
1112%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
1113if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1114 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1115 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1116 exit 1 \
1117 fi \
1118else \
1119 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1120 /usr/sbin/useradd \\\
b5a7d552 1121 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
1122 -u %{-u*} \\\
1123 -r \\\
1124 -d %{-d*}%{!-d:/usr/share/empty} \\\
1125 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 1126 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
1127 -g %{-g*} \\\
1128 %{-M} \\\
1129 %{-G:-G %{-G*}} \\\
1aac682a 1130 %{expand:%{%{#}}} 1>&2 || exit $? \
bcf63b58 1131 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
90627280 1132fi;
611a25d5 1133# vim: "
90627280 1134
90627280
ER
1135# Usage:
1136# %groupadd [-P package] [-g gid] group
1137#
1138# -g gid. REQUIRED
1139#
1140# Sample:
1141# %groupadd -P %{name}-base -g %{gid} %{name}
1142
1143%groupadd(g:P:rfo) \
9ba02ba9
ER
1144%{!-g:%{error:groupadd: Required argument -g missing}} \
1145%{!?1:%{error:groupadd: Required parameter group missing}} \
637962e6 1146if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
90627280
ER
1147 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1148 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1149 exit 1 \
1150 fi \
1151else \
1152 echo "Adding group %{1} GID=%{-g*}." \
1aac682a 1153 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
bcf63b58 1154 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
90627280 1155fi;
7cb77741 1156
7c50f037 1157# webapp macros
4c73bc69 1158# Author: Elan Ruusamäe <glen@pld-linux.org>
35663282
ER
1159#
1160# The config is installed/removed inside trigger, this means that you can any
1161# time install apache1/apache/lighttpd package and the configuration file is
fe6c4bdd 1162# updated. if you don't need the config for various reason for specific
35663282
ER
1163# webserver, just remove the symlink from config directory using webapp
1164# program. the trigger will not recreate the symlink on upgrades. In other
1165# words the config is linked to webserver config directory on first install of
1166# PACKAGE or WEBSERVER.
1167#
7c50f037
ER
1168# Add package's webserver config to webserver webapps dir.
1169# Usage:
aea687a7 1170# %webapp_register [-f] WEBSERVER WEBAPP
35663282 1171#
aea687a7 1172%webapp_register(f) \
35663282 1173%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
aea687a7 1174if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
35663282
ER
1175 /usr/sbin/webapp register %1 %2\
1176fi\
694a8f2e 1177# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
5d3a09a3 1178if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
16897aea 1179 %{expand:%service -q %%1 reload}\
35663282
ER
1180fi\
1181%{nil}
1182
1183# Remove package's config from webserver webapps dir.
35663282 1184# Usage:
531c0efc
ER
1185# %webapp_register [-f] WEBSERVER WEBAPP
1186%webapp_unregister(f) \
35663282
ER
1187%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1188# remove link if either of the packages are gone \
5d3a09a3 1189if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
df979130 1190 /usr/sbin/webapp unregister %1 %2\
16897aea 1191 %{expand:%service -q %%1 reload}\
35663282
ER
1192fi \
1193%{nil}
1194
462b26fa 1195# service macro.
4c73bc69 1196# Author: Elan Ruusamäe <glen@pld-linux.org>
462b26fa
ER
1197#
1198# calls usual service restart on package %post, but skips the restart if
1199# administrator has disabled automatic service restarts in either global
1200# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1201#
462b26fa 1202# Usage:
7377b5ca 1203# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa 1204#
a0bbe604 1205# -q be silent when service isn't started (for scriplets restaring other package's services)
7377b5ca 1206# -n NOOP mode, do not actually restart service
462b26fa 1207#
7377b5ca
ER
1208# Requirements:
1209# BuildRequires: rpmbuild(macros) >= 1.268
1210# Requires: rc-scripts
1211# -n option:
1212# BuildRequires: rpmbuild(macros) >= 1.450
1213%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
6aedae62
ER
1214
1215
f9aa75bf
ER
1216# Java macros. based on jpackage macros.java
1217#
1218# Root directory where all Java VMs/SDK/JREs are installed.
2d4659a1 1219%_jvmdir %{_libdir}/jvm
f9aa75bf
ER
1220
1221# Root directory where all Java VMs/SDK/JREs expose their jars
2d4659a1 1222%_jvmjardir %{_libdir}/jvm-exports
f9aa75bf
ER
1223
1224# Root directory for all Java VM/SDK/JRE's private things.
1225%_jvmprivdir %{_libdir}/jvm-private
1226
1227# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
2d4659a1 1228%_jvmlibdir %{_libdir}/jvm
f9aa75bf
ER
1229
1230# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1231%_jvmdatadir %{_datadir}/jvm
1232
1233# Root directory for all configurations parts of Java VM/SDK/JRE's
1234%_jvmsysconfdir %{_sysconfdir}/jvm
1235
1236# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
f5ed4276 1237%_jvmcommonlibdir %{_libdir}/jvm-common
f9aa75bf
ER
1238
1239# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
f5ed4276 1240%_jvmcommondatadir %{_datadir}/jvm-common
f9aa75bf
ER
1241
1242# Root directory for all common configurations parts of Java VM/SDK/JRE's
f5ed4276 1243%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
f9aa75bf
ER
1244
1245# Directory where arch-specific (JNI) version-independent jars are installed.
2d4659a1 1246%_jnidir %{_libdir}/java
f9aa75bf 1247
ed644e79
JK
1248
1249# JDK selection. Set this to name of the JDK implementation to use
1250# insead of the system default
1251#%use_jdk icedtea6
1252
1253# expands to the value with right jdk for BuildRequires header
1254# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1255# The requirement will not replace current 'default' JDK
1256%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1257
1258%buildrequires_jdk BuildRequires: %required_jdk
1259
1260%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
6aedae62 1261
e0e23dcd 1262%_javasrcdir %{_usrsrc}/java
1263
a9254650 1264%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
fe6c4bdd 1265%jar %{java_home}/bin/jar
ed644e79 1266%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
fe6c4bdd
ER
1267%javac %{java_home}/bin/javac
1268%javadoc %{java_home}/bin/javadoc
6aedae62 1269
fe6c4bdd 1270%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
6aedae62
ER
1271
1272%jpackage_script() \
3ca65b87
ER
1273install -d $RPM_BUILD_ROOT%{_bindir}\
1274cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
6aedae62
ER
1275#!/bin/sh\
1276#\
1277# %{name} script\
1278# JPackage Project <http://www.jpackage.org/>\
1279\
1280# Source functions library\
1281. %{_javadir}-utils/java-functions\
1282\
1283# Source system prefs\
3ca65b87 1284if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
fe6c4bdd 1285 . %{_sysconfdir}/java/%{name}.conf\
6aedae62
ER
1286fi\
1287\
1288# Source user prefs\
3ca65b87
ER
1289if [ -f $HOME/.%{name}rc ]; then\
1290 . $HOME/.%{name}rc\
6aedae62
ER
1291fi\
1292\
1293# Configuration\
1294MAIN_CLASS=%1\
1295BASE_FLAGS=%2\
1296BASE_OPTIONS=%3\
3ca65b87 1297BASE_JARS="%(echo %4 | tr ':' ' ')"\
6aedae62
ER
1298\
1299# Set parameters\
1300set_jvm\
3ca65b87
ER
1301set_classpath $BASE_JARS\
1302set_flags $BASE_FLAGS\
1303set_options $BASE_OPTIONS\
6aedae62
ER
1304\
1305# Let's start\
3ca65b87 1306run "$@"\
6aedae62
ER
1307EOF
1308
06f11871
ER
1309# jpackage 1.7
1310# Directory for maven depmaps
1311#
1312%_mavendepmapdir /etc/maven
1313%_mavendepmapfragdir /etc/maven/fragments
1314
1315#
1316# add_to_depmap adds an entry to the depmap. The arguments are:
1317#
1318# %1 the original groupid
1319# %2 the original artifact id
1320# %3 the version
1321# %4 the new groupid
1322# %5 the new artifactid
1323#
1324
1325%add_to_maven_depmap() \
1326install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1327cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1328<dependency>\
1329 <maven>\
1330 <groupId>%1</groupId>\
1331 <artifactId>%2</artifactId>\
1332 <version>%3</version>\
1333 </maven>\
1334 <jpp>\
1335 <groupId>%4</groupId>\
1336 <artifactId>%5</artifactId>\
1337 <version>%3</version>\
1338 </jpp>\
1339</dependency>\
1340\
1341EOF\
1342%{nil}
1343
1344#==============================================================================
1345#
1346# update_maven_depmap updates the main maven depmap
1347#
1348%update_maven_depmap() \
1349echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1350if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1351cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1352fi\
1353echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1354
02c5f99a 1355# JAVA macros specific for PLD
1356
1357# Directory for tomcat context configuration files
1358%_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
06f11871 1359
89c2423f 1360# Tomcat cache path
1361%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1362
1363# Clear tomcat cache
1364# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1365#
1366# Usage:
1367# %%tomcat_clear_cache appname
1368#
e09b1b1b 1369# Call this script in %postun scriptlet. It will remove compiled jsps related to
89c2423f 1370# given app.
1371#
1372%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1373
59d3ebe9 1374# PEAR install macros
4c73bc69 1375# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1376#
1377# Usage:
f7ecf326 1378# %%pear_package_setup ...
dfce8b19 1379#
59d3ebe9 1380# -a # - also unpack SOURCE#. for PEAR bootstrapping
43d992d6 1381# -n FMT - create builddir with FMT, instead of default %%{pearname}-%%{version}
59d3ebe9 1382# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
f7ecf326
ER
1383# -D - pass -D to %setup (so the build dir is not removed)
1384# -c - register channel from local channel.xml file
11a40e7b 1385# -d - pass -d arg to pearcmd
dfce8b19
ER
1386#
1387# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1388# destination hierarchy. you should copy the tree to buildroot after
1389# patching/reorganizing with %%pear_package_install.
1390#
1391# additionally BUILDROOT is stripped from files and files are converted to UNIX
1392# line endings.
1393#
1394# the pear install process output is recorded to install.log, you should put it
8763f51e 1395# to %%doc for later debug or just for information.
dfce8b19
ER
1396#
1397# additionally additional-packages.txt is produced if it was detected that the
1398# package has optional dependencies. the file format is suitable of displaying
1399# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1400# automatically added for this file.
59d3ebe9
ER
1401
1402
1403# records install.log and transforms PEAR names to PLD Linux rpm package names.
1404%__pear_install_log \
1405tee install.log \
1406# make post message of optional packages \
5ad4663a 1407grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
59d3ebe9
ER
1408if [ -s optional-packages.txt ]; then \
1409 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1410else \
1411 rm -f optional-packages.txt \
1412fi \
1413%{nil}
1414
e98e79d4
ER
1415# Command invoking PEAR CLI
1416# Same as /usr/bin/pear, except we force GMT timezone
1417%__pear %__php -doutput_buffering=1 -dopen_basedir="" -dmemory_limit=-1 -ddate.timezone=GMT %{php_pear_dir}/pearcmd.php
59d3ebe9 1418
11a40e7b 1419%pear_install(a:d:n:zD) \
59d3ebe9 1420%__pear \\\
f7ecf326 1421 -c %{builddir}/pearrc \\\
dfce8b19 1422 -d doc_dir=/docs \\\
f7ecf326
ER
1423 -d temp_dir=/tmp \\\
1424 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
dfce8b19
ER
1425 -d bin_dir=%{_bindir} \\\
1426 -d data_dir=%{php_pear_dir}/data \\\
1427 -d test_dir=%{php_pear_dir}/tests \\\
11a40e7b 1428 %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
dfce8b19 1429 install \\\
59d3ebe9 1430 --packagingroot=%{builddir} \\\
dfce8b19
ER
1431 --offline \\\
1432 --nodeps \\\
1433 %{-f:--force} \\\
67a089ff 1434 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
b872fad7 1435 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
67a089ff
ER
1436%{nil}
1437
1438# The main macro.
1439# using this macro will append optional-packages.txt to the nocompressdoc list
1440# as it's displayed to user after package install. and adding additional gzip
1441# dep is just waste ;)
11a40e7b 1442%pear_package_setup(a:d:n:zDc:) \
43d992d6 1443%define srcdir %{-n*}%{!-n:%{?_pearname}%{!?_pearname:%{pearname}}-%{version}} \
67a089ff
ER
1444%define builddir %{_builddir}/%{srcdir} \
1445%setup -q -c -T %{-D:-D} -n %{srcdir} \
a4b4c90f 1446%{-z:%{__tar} zxf %{S:0}; %{-a:%{__tar} zxf %{S:%{-a*}}}} \
67a089ff 1447%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
f7ecf326 1448%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
67a089ff 1449%pear_install \
59d3ebe9 1450%{-z:cd ..} \
a4b4c90f 1451%{__tar} --wildcards -zvxf %{S:0} package*.xml \
59d3ebe9 1452cat %{-z:$_N/}.install.log | %__pear_install_log \
208a11f6 1453%undos -f php,html,js,xml \
dfce8b19
ER
1454%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1455%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1456%{nil}
1457
7bef60e8 1458# Copies exctracted PEAR package structure and PEAR registry to buildroot.
4c73bc69 1459# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1460%pear_package_install() \
1461cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1462find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1463# help the developer out a little: \
1464if [ -f _noautoreq ]; then \
1465 echo "AutoReqdep detected:" \
1466 echo "_noautoreq $(cat _noautoreq)" \
1467fi \
1468%{nil}
1469
cc8d4be7
ER
1470# Print optional package info for pear packages
1471# Author: Elan Ruusamäe <glen@pld-linux.org>
1472# Usage:
1473# %post -p <lua>
1474# %%pear_package_print_optionalpackages
1475#
1476# Requirements:
1477# BuildRequires: rpmbuild(macros) >= 1.571
1478%pear_package_print_optionalpackages \
1479f = io.open("%{_docdir}/%{name}-%{version}/optional-packages.txt", "r") \
1480if f then \
1481 for l in f:lines() do print(l); end \
1482end \
1483%{nil}
1484
0d5dd00c
ER
1485
1486# Register OpenLDAP schema.
4c73bc69 1487# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1488#
1489# Usage:
1490# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1491#
1492# -d specify dependant schemas, separated by comma
1493#
1494%openldap_schema_register(d:) \
1495for schema in %*; do \
1496 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1497 %{__sed} -i -e " \
1498 /^include.*local.schema/{ \
1499 iinclude\\t $schema\
1500 } \
1501 " /etc/openldap/slapd.conf \
1502 fi \
1503done \
1504# enable dependant schemas \
1505if [ "%{-d*}" ]; then \
1506 %{__sed} -i -e ' \
1507 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1508 s/^#// \
1509 }' /etc/openldap/slapd.conf \
1510fi \
1511%{nil}
1512
1513# Unregister OpenLDAP schema.
4c73bc69 1514# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1515#
1516# Usage:
1517# %%openldap_schema_unregister %{schemadir}/horde.schema
1518#
1519%openldap_schema_unregister() \
1520for schema in %*; do \
1521 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1522 %{__sed} -i -e " \
1523 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1524 # for symmetry it would be nice if we disable enabled schemas in post, \
1525 # but we really can not do that, it would break something else. \
1526 " /etc/openldap/slapd.conf \
1527 fi \
1528done \
1529%{nil}
1530
b0bc2936 1531%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
d834e0a1 1532
dcc6baf7 1533
1534# Build modules for kernels 2.6
1535# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1536#
1537# Usage:
aa559e46 1538# %build_kernel_modules -m <modules> -C <directory>
dcc6baf7 1539#
1540# remember that proper Makefile is still required
1541# Options:
990bd03f 1542# -m <modules> (required) -- comma-separated list of modules to save,
dcc6baf7 1543# without .ko extension, may be placed in subdirectory
aa559e46 1544# -C <directory> -- change to <directory> before doing anything
dcc6baf7 1545# -p <arg>, -P <arg> -- arguments passeed to make scripts
5a81d83e 1546# -c -- do not execute make clean
dcc6baf7 1547# <additional arguments> -- all additional arguments will be passed to
1548# make modules
1549#
1550# Additional patching supported via here document. Try:
1551# %build_kernel_modules -m module <<'EOF'
1552# your patch script here
1553# EOF
1554# Don't use it unless patching depends on config options.
1555
1556# Developer note: don't touch it unless you know how to handle '\'.
1557# - \ in script expands to nothing
1558# - \\\ in script expands to \
566398b4 1559# - \\\ inside definition expands to nothing
dcc6baf7 1560# - \\\\\\\ inside definition expands to \
1561# - in last line \ has to touch arguments so arguments passing
1562# in new lines (using \) will be supported
1563
5a81d83e 1564%build_kernel_modules(p:P:m:C:c) \
dcc6baf7 1565%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1566 \
1567%define Opts \\\\\\\
1568%if "%{_target_base_arch}" != "%{_arch}" \\\
1569 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
88608ef7 1570 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
dcc6baf7 1571 %else \\\
1572 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1573 %endif \\\
1574%else \\\
88608ef7 1575 CC="%{kgcc}" \\\
dcc6baf7 1576%endif \
88608ef7 1577%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
dcc6baf7 1578 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1579 \
e364bc26 1580%{?-C:cd %{-C*}} \
dcc6baf7 1581compile() { \
ba9de9b2
ER
1582 local L="<" PATCH_SH; \
1583 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
dcc6baf7 1584 set -e -x \
730239f9 1585 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1586 \
730239f9 1587for cfg in ${cfgs:-dist}; do \
dcc6baf7 1588 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1589 \
c546f6fb 1590 rm -rf o \
ec8cb195 1591 install -d o/include/linux o/include/generated o/arch/powerpc/lib \
dcc6baf7 1592 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1593 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
ec8cb195
AM
1594 if [ -f %{_kernelsrcdir}/include/generated/autoconf-$cfg.h ]; then \
1595 ln -sf %{_kernelsrcdir}/include/generated/autoconf-$cfg.h o/include/generated/autoconf.h \
a2a36b0c 1596 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
ec8cb195
AM
1597 else \
1598 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1599 fi \
dcc6baf7 1600 \
1601 set +x \
1602 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1603 set -x \
1604 \
c768535c 1605 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
dcc6baf7 1606 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1607 %{-p*} %{-P*} \\\
1608 %{MakeOpts} \
1609 %else \
1610 install -d o/include/config \
1611 touch o/include/config/MARKER \
588f1b0b 1612 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
dcc6baf7 1613 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1614 %endif \
1615 \
5a81d83e 1616 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
dcc6baf7 1617 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
f635907b 1618 ${1+"$@"} \\\
5a81d83e 1619 M=$PWD %{MakeOpts}} \
f635907b 1620 \
dcc6baf7 1621 %{__make} -C %{_kernelsrcdir} modules \\\
1622 ${1+"$@"} \\\
1623 M=$PWD %{MakeOpts} \
1624 \
1625 for MODULE in {%{-m*},}; do \
1626 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1627 done \
1628done \
aa559e46 1629%{?-C:cd -} \
dcc6baf7 1630} \
1631compile %{*}\
1632%{nil}
1633
1634
1635# Install kernel modules built by %build_kernel_modules
1636# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1637#
1638# Usage:
1639# %install_kernel_modules -m <modules> -d <directory>
1640#
1641# Options:
990bd03f 1642# -m <modules> (required) -- comma-separated list of modules to install,
dcc6baf7 1643# without .ko extension, may be placed in subdirectory
1644# -d <directory> (required) -- in what subdirectory modules should be
1645# installed (eg. misc, kernel/drivers/net)
1646# -s <suffix> -- suffix to use when installing modules, useful when module
1647# with same name exists in kernel already
1648# -n <file> -- name of modprobe config file to use (without .conf extension)
00395cf1 1649# for defining aliases, only useful with -s
dcc6baf7 1650
1651%install_kernel_modules(m:d:s:n:) \
1652%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1653%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1654%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1655 \
1656%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1657%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
412786d1 1658 \
b279feda 1659__install_kernel_modules() { \
730239f9 1660local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1661 \
1662for MODULE in {%{-m*},}; do \
1663 [ -n "${MODULE}" ] || continue \
730239f9
ER
1664 for cfg in ${cfgs:-dist}; do \
1665 [ "$cfg" = smp ] && suf=smp || suf= \
1666 MNAME=${MODULE##*/} \
1667 install -D ${MODULE}-$cfg.ko \\\
1668 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b9460afb 1669 %{?-s:install -d %{ModprobeD}$suf \
730239f9
ER
1670 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1671 >> %{ModprobeD}$suf/%{-n*}.conf} \
1672 done \
dcc6baf7 1673done \
b279feda 1674} \
1675__install_kernel_modules \
dcc6baf7 1676%{nil}
1677
fa65356c 1678# patchset macros
4c73bc69 1679# Author: Elan Ruusamäe <glen@pld-linux.org>
fa65356c
ER
1680#
1681# Usage:
1682# %patchset_source -f <seq(1) format> <start> [<end>]
1683# %patchset_patch <start> [<end>]
1684#
1685# If <end> is omited, it is assumed to be <start>.
1686#
1687# For example in preamble:
1688# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1689# and in %prep:
1690# %patchset_patch 33 44
1691
1692# generate SourceX urls from range START STOP
1693# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1694# The sources start from 10000
e91610db 1695%patchset_source(f:b:) %(
44f733ef 1696 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1697 start=$(expr $base + %1);
1698 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1699 # we need to call seq twice as it doesn't allow two formats
1700 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1701 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1702 paste %{tmpdir}/__ps{1,2};
1703 rm -f %{tmpdir}/__ps{1,2};
962f9ecf
ER
1704) \
1705%{nil}
fa65356c
ER
1706
1707# apply sources from %patchset_source
1708# -p specify -pX for %patch line
1709# -b base offset: defaults to 10000
1710%patchset_patch(f:p:b:) %(
44f733ef 1711 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1712 start=$(expr $base + %1);
1713 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1714 echo ": patchset_patch %1%{?2: to %2}";
1715 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
962f9ecf
ER
1716) \
1717%{nil}
fa65356c 1718
5730b44b 1719# browser plugins v2
4c73bc69 1720# Author: Elan Ruusamäe <glen@pld-linux.org>
5730b44b
ER
1721#
1722# Usage:
1723# %browser_plugins_add_browser <name> -p <plugindir>
1724#
1725# <name> (required) -- name of the browser. usually %{name}.
1726# -p <plugindir> (required) -- in what directory browser searches for its plugins.
02ebf70f
ER
1727# -b -- default blacklists
1728# -a <arch> override arch
5730b44b
ER
1729#
1730# Example:
1731# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1732
1733%_browserpluginsconfdir /etc/browser-plugins
5e19a4dc 1734%_browserpluginsdir %{_libdir}/browser-plugins
5730b44b
ER
1735%update_browser_plugins /usr/sbin/update-browser-plugins || :
1736
02ebf70f 1737%browser_plugins_add_browser(p:b:a:) \
9efd458e 1738 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
5730b44b 1739 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
02ebf70f
ER
1740 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1741 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
5730b44b
ER
1742 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1743 %{-b:cat >> $blacklist_file %{-b*}} \
1744%{nil}
1745
ad17b654
ER
1746# Helper for LUA.
1747# split string separated by space into quoted list
1748#
4c73bc69 1749# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1750#
1751# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1752%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1753
1754# adjust /etc/shells by adding and removing shells from there
4c73bc69 1755# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1756#
1757# Usage:
d9b789d9
ER
1758# %post -p <lua>
1759# %lua_add_etc_shells /bin/sh /bin/pdksh
ad17b654 1760#
d9b789d9
ER
1761# %preun -p <lua>
1762# if arg[2] == 0 then
1763# %lua_remove_etc_shells /bin/bash /bin/rbash
1764# end
7377b5ca
ER
1765#
1766# Requirements:
d9b789d9
ER
1767# BuildRequires: rpmbuild(macros) >= 1.462
1768#
ad17b654 1769
d9b789d9 1770%lua_add_etc_shells() \
ad17b654
ER
1771t = {}\
1772f = io.open("/etc/shells", "r")\
1773if f then\
1774 for l in f:lines() do t[l]=l; end\
1775 f:close()\
1776end\
1777for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1778 if not t[s] then\
b8c0bc18 1779 print("Adding "..s.." to /etc/shells")\
ad17b654
ER
1780 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1781 end\
1782end\
1783%{nil}
1784
d9b789d9
ER
1785%lua_remove_etc_shells() \
1786t = {}\
1787f = io.open("/etc/shells", "r")\
1788if f then\
1789 for l in f:lines() do t[l]=l; end\
1790 f:close()\
1791end\
1792for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1793 print("Removing "..l.." from /etc/shells")\
1794 t[l] = nil\
1795end\
1796s=""\
1797for _, l in pairs(t) do\
1798 s=s..l.."\\n"\
1799end\
1800io.open("/etc/shells", "w"):write(s)\
1801%{nil}
1802
1803# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1804#
1805# Author: Elan Ruusamäe <glen@pld-linux.org>
1806#
1807# Usage:
1808# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1809# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1810#
1811# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1812#
1813# Requirements:
1814# BuildRequires: rpmbuild(macros) >= 1.429
1815#
1816%add_etc_shells(p) %{-p:<lua>}\
1817%{expand:%%lua_add_etc_shells %*}\
1818%{nil}
1819
ad17b654 1820%remove_etc_shells(p) %{-p:<lua>}\
b8c0bc18 1821%{-p:if arg[2] == 0 then}\
d9b789d9 1822%{expand:%%lua_remove_etc_shells %*}\
750e19f4 1823%{-p:end} \
ad17b654
ER
1824%{nil}
1825
75bd6249
ER
1826# Check syntax for Python files
1827#
1828# Author: Elan Ruusamäe <glen@pld-linux.org>
1829# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1830#
1831# Usage:
1832# %py_lint src
1833#
1834# Requirements:
1835# BuildRequires: python
1836# BuildRequires: rpmbuild(macros) >= 1.469
1837
1838%py_lint() \
1839__py_lint() { \
1840find "$@" -type f -name '*.py' | python -c ' \
1841import sys \
1842import compiler \
1843\
1844err = 0\
1845for f in sys.stdin: \
1846 fd = open(f.strip()) \
1847 c = fd.read() \
1848 fd.close() \
1849 try: \
1850 compiler.parse(c) \
1851 except SyntaxError, e: \
1852 print "py_lint: %s: %s" % (f.strip(), e) \
1853 err = err + 1\
1854\
1855if err: \
1856 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1857 sys.exit(1) \
1858else: \
1859 print >> sys.stderr, "py_lint: Found no syntax errors." \
1860' \
1861}; __py_lint %* \
1862%{nil}
1863
f602e4a0 1864# Undos files
1865#
1866# Author: Paweł Zuzelski <pawelz@pld-linux.org>
0217c63b 1867# Author: Elan Ruusamäe <glen@pld-linux.org>
f602e4a0 1868#
1869# Usage:
1870# %undos list_of_files
0217c63b
ER
1871# %undos -f EXT[,EXT]
1872# %undos -i -f EXT[,EXT]
1873#
1874# -f EXT[,EXT] - find(1) files by extensions
1875# -i - case insensitive file search
1876#
1877# Example:
1878# Un-DOS all *.js, *.css files
1879# %undos -f js,css
1880# Un-DOS all *.js, *.JS files
1881# %undos -f js -i
1882# undos all Makefiles
1883# %{__find} -name Makefile | xargs %undos
f602e4a0 1884#
1885# Requirements:
1886# BuildRequires: sed >= 4.0
81a64c94 1887# BuildRequires: rpmbuild(macros) >= 1.565
f602e4a0 1888
0217c63b 1889# NB: make sure this macro stays on one line
81a64c94
ER
1890# NB: make sure it includes newline escape
1891%undos(f:i) %{-f:%{__find} -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
1892%{nil}
f602e4a0 1893
2f79ae5a
ER
1894# Hook to register nagios object based plugins in Nagios NRPE daemon config.
1895#
1896# Author: Elan Ruusamäe <glen@pld-linux.org>
1897#
1898# Usage:
1899# -a NAME -- add command named NAME
1900# -d NAME -- remove command named NAME
1901# -f FILE -- specify plugin configuration FILE to extract command definition from
1902#
1903# Sample:
1904# %triggerin -- nagios-nrpe
1905# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1906#
1907# %triggerun -- nagios-nrpe
1908# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1909#
1910# Requirements:
f236a3c2 1911# Requires: grep
1912# Requires: sed >= 4.0
d7cee36f 1913# BuildRequires: rpmbuild(macros) >= 1.552
2f79ae5a 1914%nagios_nrpe(a:d:c:f:) {\
d7cee36f 1915 m=$(md5sum < /etc/nagios/nrpe.cfg); \
2f79ae5a 1916 %{-a:# on -a and config exists \
d7cee36f
ER
1917 if [ -f /etc/nagios/nrpe.cfg ]; then \
1918 if ! %{__grep} -q '^command\[%{-a*}\]' /etc/nagios/nrpe.cfg; then \
1919 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> /etc/nagios/nrpe.cfg; \
2f79ae5a
ER
1920 fi; \
1921 fi;} \
1922 %{-d:# on package remove, -d and config exists \
d7cee36f
ER
1923 if [ "$1" = "0" -a -f /etc/nagios/nrpe.cfg ]; then \
1924 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' /etc/nagios/nrpe.cfg; \
2f79ae5a 1925 fi;} \
d7cee36f
ER
1926 if [ "$m" != "$(md5sum < /etc/nagios/nrpe.cfg)" ]; then \
1927 %service -q nrpe restart; \
1928 fi; \
2f79ae5a
ER
1929}%{nil}
1930
070aa9f4
ER
1931# Import or update Cacti template.
1932#
1933# Author: Elan Ruusamäe <glen@pld-linux.org>
1934#
1935# Usage:
1936# %cacti_import_template XMLFILE
1937# XMLFILE -- XML template to import
1938#
1939# Sample:
1940# %post
1941# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
1942#
1943# Requires: cacti >= 0.8.7e-8
1944# BuildRequires: rpmbuild(macros) >= 1.554
1945
1946%cacti_import_template() {\
1947/usr/share/cacti/cli/import_template.php --filename=%1 || :; \
1948}%{nil}
1949
cdb82983
JK
1950# pre/post script for -upstart subpackages
1951#
1952# Author: Jacek Konieczny <jajcus@jajcus.net>
1953#
1954# Usage:
1955# %upstart_post service_name
1956# %upstart_postun service_name
1957#
1958# Sample:
1959# %post upstart
1960# %upstart_post %{name}
1961#
1962# %postun upstart
1963# %upstart_postun %{name}
1964#
1965# Requirements:
1966# BuildRequires: rpmbuild(macros) >= 1.560
1967# Requires: rc-scripts >= 0.4.3
1968
1969# migrate from init script to upstart job
c4c1a53f 1970%upstart_post() \
cdb82983
JK
1971 if [ -f /var/lock/subsys/"%1" ] ; then \
1972 /sbin/service --no-upstart "%1" stop \
1973 /sbin/service "%1" start \
1974 fi
1975
1976# restart the job after upgrade or migrate to init script on removal
1977# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
1978# at this point
c4c1a53f 1979%upstart_postun() \
cdb82983
JK
1980 if [ -x /sbin/initctl ] && /sbin/initctl status "%1" 2>/dev/null | grep -q 'running' ; then \
1981 /sbin/initctl stop "%1" >/dev/null 2>&1 \
1982 [ -f "/etc/rc.d/init.d/%1" -o -f "/etc/init/%1.conf" ] && { echo -n "Re-" ; /sbin/service "%1" start ; } ; \
1983 fi
1984
f51bfb2f 1985# vim:ts=4 sw=4 noet ft=spec
This page took 0.647853 seconds and 4 git commands to generate.